import sys

def print_metapost(a):
    n = len(a)
    m = len(a[0])
    a = a[::-1]

    d = {}
    d['U'] = (1, 0)
    d['L'] = (0, -1)
    d['D'] = (-1, 0)
    d['R'] = (0, 1)

    print("prologues:=3;")
    print("verbatimtex")
    print("%&latex")
    print("\\documentclass{minimal}")
    print("\\begin{document}")
    print("etex")
    print("beginfig(0);")
    print("")

    print("h={}cm;".format(m))
    print("w={}cm;".format(n))
    print("")

    print("def draw_rect(expr xl, yl, xr, yr) =")
    print(" pair A, B, C, D;")
    print(" A := (yl, xl);")
    print(" B := (yl, xr);")
    print(" C := (yr, xr);")
    print(" D := (yr, xl);")
    print(" draw A--B--C--D--cycle;")
    print("enddef;")
    print("")

    print("def draw_letter(expr x, y, c) =")
    print(" pair A;")
    print(" A := (y, x);")
    print(" label.urt(c, A);")
    print("enddef;")
    print("")

    print("def draw_arrow(expr xs, ys, xf, yf) =")
    print(" pair A, B;")
    print(" numeric alpha;")
    print(" A := (ys, xs);")
    print(" B := (yf, xf);")
    print(" alpha = angle(B - A) + 30;")
    print(" drawarrow A{dir alpha} .. B;")
    print("enddef;")
    print("")

    dh = 1.0 / n
    dw = 1.0 / m
    print("draw_rect(%.5f*w, %.5f*h, %.5f*w, %.5f*h);" % (0 * dh, 0 * dw, n * dh, m * dw))
    for i in range(n):
        for j in range(m):
            print("draw_rect(%.5f*w, %.5f*h, %.5f*w, %.5f*h);" % ((i + 0.05) * dh, (j + 0.05) * dw, (i+0.95) * dh, (j+0.95) * dw))
            print("draw_letter(%.5f*w, %.5f*h, \"%c\");" % ((i+0.0) * dh, (j+0.0) * dw, a[i][j]))
            print("draw_arrow(%.5f*w, %.5f*h, %.5f*w, %.5f*h);" % ((i+0.5)*dh, (j+0.5)*dw,
                                                                   (i+d[a[i][j]][0]+0.5)*dh, (j+d[a[i][j]][1]+0.5)*dw))
    print("label(btex pic. %s etex, (%.5f*w, %.5f*h));" % (sys.argv[1][2], m / 2.0 * dh, -0.25 * dw))
    print("")
    print("endfig;")
    print("end")

if sys.argv[1] == '001':
    print_metapost(["RD", "UL"])
if sys.argv[1] == '002':
    print_metapost(["D", "U"])
if sys.argv[1] == '003':
    print_metapost(["RD", "RU"])
if sys.argv[1] == '004':
    print_metapost(["RL", "RL", "RL"])
if sys.argv[1] == '005':
    print_metapost(["RLRLRL"])

# print_metapost(["RD", "RU"])
# print_metapost(["RL", "RL", "RL"])
# print_metapost(["RLRLRL"])
