#include <bits/stdc++.h>
using namespace std;
using ll = long long;

// Struct for precalculation of multiplicative functions
struct Sieve {
	vector<int> primes;  // primes[i]    := i+1'th prime
	vector<int> div_ind; // div_ind[x]   := minimum i s.t. primes[i] | x
	vector<int> div_cou; // div_cou[p^k] := k+1

	Sieve(int n) : div_ind(n+1, -1), div_cou(n+1, 1) {
		vector<int> base(n+1, 1);
		for (int i = 2; i <= n; ++i) {
			if (div_ind[i] == -1) {
				div_ind[i] = primes.size();
				primes.push_back(i);
			}
			for (int j = 0; j <= div_ind[i]; ++j) {
				int t = i * primes[j];
				if (t > n) break;
				div_ind[t] = j;
				base[t] = (j == div_ind[i] ? base[i] : i);
			}

			// Calculate multiplicative functions
			int bs = base[i];
			if (bs == 1) {
				int p = primes[div_ind[i]];
				int j = i/p;
				div_cou[i] = div_cou[j] + 1;
			} else {
				int pk = i/bs;
				div_cou[i] = div_cou[bs] * div_cou[pk];
			}
		}
	}
};

const int N = 30000;
bitset<N> up, down, lft, rht;
bitset<N> valid[3][3];
bitset<N> rows[3];
int nxt[N + 1][3];

void combine(bitset<N>& res, const bitset<N>& a, const bitset<N>& b) {
	res = a ^ b;
}
void combine(bitset<N>& res, const bitset<N>& a, const bitset<N>& b, const bitset<N>& c) {
	res = (a ^ b ^ c);
	res ^= a & b & c;
}
void combine(bitset<N>& res, const bitset<N>& a, const bitset<N>& b, const bitset<N>& c, const bitset<N>& d) {
	res = (a ^ b ^ c ^ d);
	res ^= res & ((a & b) | (c & d));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string str;
	cin >> str;
	int n = str.size();

	for (int i = 0; i < n; ++i) {
		up[i] = (str[i] == 'U');
		down[i] = (str[i] == 'D');
		lft[i] = (str[i] == 'L');
		rht[i] = (str[i] == 'R');
	}
	
	lft >>= 1;
	rht <<= 1;
	down <<= 1;
	up >>= 1;
	
	// Count those with both width and height at least 2
	ll res = 0;
	for (int k = 2; 2 * k <= n; ++k) {
		down <<= 1;
		up >>= 1;

		combine(valid[0][0], up, lft);
		combine(valid[1][0], up, down, lft);
		combine(valid[2][0], down, lft);
		combine(valid[0][1], up, lft, rht);
		combine(valid[1][1], up, down, lft, rht);
		combine(valid[2][1], down, lft, rht);
		combine(valid[0][2], up, rht);
		combine(valid[1][2], up, down, rht);
		combine(valid[2][2], down, rht);
	
	
	
		for (int j = 0; j < 3; ++j) nxt[n][j] = n;
		for (int i = n-1; i >= 0; --i) {
			for (int j = 0; j < 3; ++j) nxt[i][j] = (valid[j][1][i] ? nxt[i + 1][j] : i);
		}

		for (int j = 0; j < 3; ++j) rows[j].reset();
		for (int i = 0; i + k <= n; ++i) {
			for (int j = 0; j < 3; ++j) {
				rows[j][i] = (valid[j][0][i] && valid[j][2][i + k - 1] && nxt[i + 1][j] >= i + k - 1);
			}
		}

		for (int j = 0; j < k; ++j) {
			int cur = 0;
			for (int i = j; i < n; i += k) {
				if (rows[2][i]) res += cur;
				if (! rows[1][i]) cur = 0;
				if (rows[0][i]) ++cur;
			}
		}
	}

	Sieve sv(n);
	vector<ll> adds(n + 1, 0);
	for (int i = 1; i <= n; ++i) adds[i] = 2 - sv.div_cou[i] + adds[i - 1];


	// Count all others
	for (int j = 0; j < 2; ++j) {
		int cur = 0, tp = 0;
		for (int i = j; i + 1 < n; i += 2) {
			if (str[i] == 'D' && str[i + 1] == 'U') {
				if (tp == -1) cur = 0;
				++cur;
				res += cur;
				tp = 1;
			} else if (str[i] == 'R' && str[i + 1] == 'L') {
				if (tp == 1) cur = 0;
				++cur;
				res += adds[cur];
				tp = -1;
			} else {
				cur = 0;
				tp = 0;
			}
		}
	}
	cout << res << '\n';
}
