import java.util.Scanner;

public class Admissible_bm {
    public static long solve(char[] s) {
        int k = s.length;

        char[] dc = "ULDR".toCharArray();
        int[] a = new int[k];
        for (int i = 0; i < a.length; i++) {
            while (dc[a[i]] != s[i]) {
                a[i] += 1;
            }
        }

        BitSet[] b = new BitSet[4];
        for (int i = 0; i < b.length; i++) {
            b[i] = new BitSet(k);
        }
        for (int i = 0; i < k; i++) {
            b[a[i]].setBit(i);
        }
        BitSet[] bn = new BitSet[b.length];
        for (int i = 0; i < bn.length; i++) {
            bn[i] = b[i].not();
        }

        BitSet allowed = new BitSet(k);
        for (int i = 0; i < k; i++) {
            allowed.setBit(i);
        }

        BitSet[] good = new BitSet[k / 2];
        for (int i = 0; i < good.length; i++) {
            good[i] = new BitSet(k);
        }
        for (int m = 1; m * 2 <= k; m++) {
            BitSet[] cb = new BitSet[b.length];
            for (int i = 0; i < cb.length; i++) {
                cb[i] = b[i].makeCopy();
            }
            cb[0] = cb[0].shiftRight(m);
            cb[1] = cb[1].shiftRight(1);
            cb[2] = cb[2].shiftLeft(m);
            cb[2].andEq(allowed);
            cb[3] = cb[3].shiftLeft(1);
            cb[3].andEq(allowed);

            BitSet neibUL = cb[2].or(cb[3]);
            BitSet neibDR = cb[0].or(cb[1]);
            BitSet neibUR = cb[1].or(cb[2]);
            BitSet neibLD = cb[0].or(cb[3]);

            BitSet neibAny = neibUL.or(neibDR);
            BitSet neibULD = neibUL.or(cb[0]);
            BitSet neibULR = neibUL.or(cb[1]);
            BitSet neibUDR = neibDR.or(cb[2]);
            BitSet neibLDR = neibDR.or(cb[3]);

            BitSet good_up_start = neibLDR.and(bn[0]).allNextMones(m).and(neibDR).and(neibLD.shiftRight(m - 1));
            BitSet good_mid_start = neibAny.allNextMones(m).and(neibUDR).and(neibULD.shiftRight(m - 1)).and(bn[1]).and(bn[3].shiftRight((m - 1)));
            BitSet good_bot_start = neibULR.and(bn[2]).allNextMones(m).and(neibUR).and(neibUL.shiftRight(m - 1));

            BitSet cur = good_up_start.and(good_mid_start);
            for (int n = 2; m * n <= k; n++) {
                int shift = (n - 1) * m;
                cur.andEq(good_mid_start.shiftRight(shift));
                if (n * m % 2 == 0) {
                    good[m * n / 2 - 1].orEq(cur.and(good_bot_start.shiftRight(shift)));
                }
            }
        }

        long ans = 0;
        for (BitSet bt : good) {
            ans += bt.countOnes();
        }
        for (int i = 0; i + 1 < k; i++) {
            if (s[i] == 'R' && s[i + 1] == 'L') {
                ans += 1;
            }
        }

        return ans;
    }

    static class BitSet {
        long[] a;

        BitSet(int numBits) {
            a = new long[(numBits + 63) / 64];
        }

        BitSet(long[] a) {
            this.a = a;
        }

        void setBit(int idx) {
            a[idx >> 6] |= 1L << (idx & 63);
        }

        boolean isSet(int idx) {
            return (a[idx >> 6] & (1L << (idx & 63))) != 0;
        }

        BitSet not() {
            long[] na = new long[a.length];
            for (int i = 0; i < a.length; i++) {
                na[i] = ~a[i];
            }
            return new BitSet(na);
        }

        BitSet makeCopy() {
            return new BitSet(a.clone());
        }

        BitSet shiftRight(int len) {
            int full = len / 64;
            int part = len & 63;
            long[] na = new long[a.length];
            for (int i = full; i < a.length; i++) {
                na[i - full] |= a[i] >>> part;
                if (part != 0 && i > full) {
                    na[i - full - 1] |= (a[i] << (64 - part));
                }
            }
            return new BitSet(na);
        }

        BitSet shiftLeft(int len) {
            int full = len / 64;
            int part = len & 63;
            long[] na = new long[a.length];
            for (int i = 0; i + full < a.length; i++) {
                na[i + full] |= a[i] << part;
                if (part != 0 && i + full + 1 < a.length) {
                    na[i + full + 1] |= (a[i] >>> (64 - part));
                }
            }
            return new BitSet(na);
        }

        void andEq(BitSet another) {
            for (int i = 0; i < a.length; i++) {
                a[i] &= another.a[i];
            }
        }

        void orEq(BitSet another) {
            for (int i = 0; i < a.length; i++) {
                a[i] |= another.a[i];
            }
        }

        BitSet or(BitSet another) {
            long[] na = new long[a.length];
            for (int i = 0; i < a.length; i++) {
                na[i] = a[i] | another.a[i];
            }
            return new BitSet(na);
        }

        BitSet and(BitSet another) {
            long[] na = new long[a.length];
            for (int i = 0; i < a.length; i++) {
                na[i] = a[i] & another.a[i];
            }
            return new BitSet(na);
        }

        BitSet allNextMones(int m) {
            BitSet bt = makeCopy();
            int cur = 1;
            while (cur * 2 <= m) {
                bt.andEq(bt.shiftRight(cur));
                cur *= 2;
            }
            if (m - cur != 0) {
                bt.andEq(bt.shiftRight(m - cur));
            }
            return bt;
        }

        int countOnes() {
            int res = 0;
            for (long x : a) {
                res += Long.bitCount(x);
            }
            return res;
        }

        String debugToString() {
            StringBuilder sb = new StringBuilder();
            sb.append("{");
            boolean prev = false;
            for (int i = 0; i < a.length * 64; i++) {
                if (isSet(i)) {
                    if (prev) {
                        sb.append(", ");
                    }
                    sb.append(i);
                    prev = true;
                }
            }
            sb.append("}");
            return sb.toString();
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println(solve(sc.nextLine().toCharArray()));
    }
}
