#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int solve(const string &s) {
    const int N = 3.01e4;
    int k = s.length();

    const vector<int> dx = {-1, 0, 1, 0};
    const vector<int> dy = {0, -1, 0, 1};
    const vector<char>dc = {'U', 'L', 'D', 'R'};
    vector<int> a(k);
    for (int i = 0; i < k; i++) while (dc[a[i]] != s[i]) a[i]++;

    vector<bitset<N>> b(4);
    for (int i = 0; i < k; i++) b[a[i]][i] = 1;
    vector<bitset<N>> bn(4);
    for (int i = 0; i < 4; i++) bn[i] = ~b[i];

    auto all_next_m_ones = [&](bitset<N> bt, int m) {
        int cur = 1;
        while (cur * 2 <= m) {
            bt &= bt >> cur;
            cur *= 2;
        }
        if (m - cur) bt &= bt >> (m - cur);
        return bt;
    };

    vector<bitset<N>> good(k);
    for (int m = 1; m <= k; m++) {
        auto cb = b;
        cb[0] >>= m;
        cb[1] >>= 1;
        cb[2] <<= m;
        cb[3] <<= 1;

        auto neibUL = cb[2] | cb[3];
        auto neibDR = cb[0] | cb[1];
        auto neibUR = cb[1] | cb[2];
        auto neibLD = cb[0] | cb[3];

        auto neibAny = neibUL | neibDR;
        auto neibULD = neibUL | cb[0];
        auto neibULR = neibUL | cb[1];
        auto neibUDR = neibDR | cb[2];
        auto neibLDR = neibDR | cb[3];

        auto good_up_start = all_next_m_ones(neibLDR & bn[0], m) & neibDR & (neibLD >> (m - 1));
        auto good_mid_start = all_next_m_ones(neibAny, m) & neibUDR & (neibULD >> (m - 1)) & bn[1] & (bn[3] >> (m - 1));
        auto good_bot_start = all_next_m_ones(neibULR & bn[2], m) & neibUR & (neibUL >> (m - 1));

        good_up_start &= good_mid_start;
        for (int l = good_up_start._Find_first(); l < k; l = good_up_start._Find_next(l)) {
            for (int r = l + m; r + m - 1 < k; r += m) {
                if (!good_mid_start[r]) break;
                if (good_bot_start[r]) {
                    good[l][r + m - 1] = 1;
                }
            }
        }
    }
    ll ans = 0;
    for (auto bt : good) ans += bt.count();
    for (int i = 0; i + 1 < k; i++) if (s[i] == 'R' && s[i + 1] == 'L') ans++;
    return ans;
}

int main() {
    string s;
    while (cin >> s) {
        cout << solve(s) << endl;
    }
    return 0;
}
