#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int fastest(const string &s) {
    int k = s.length();
    string dc = "ULDR";
    vector<int> a(k);
    for (int i = 0; i < k; i++) while (dc[a[i]] != s[i]) a[i]++;

    vector<vector<int>> nxt(k + 1, vector<int>(4, k));
    for (int i = k - 1; i >= 0; i--) {
        nxt[i] = nxt[i + 1];
        nxt[i][a[i]] = i;
    }
    vector<int> m(k, -1);
    vector<int> lr(k + 2);
    for (int i = k - 1; i >= 0; i--) {
        if (s.substr(i, 2) == "RL") lr[i] = lr[i + 2] + 1;
        int j = i + lr[i] * 2;
        if (j == k) continue;
        if (s[j] == 'R') {
            if (nxt[j][0] != k) m[i] = nxt[j][0] - j;
        } else if (s[j] == 'D') {
            int t = min({nxt[j + 1][0], nxt[j + 1][2], nxt[j + 1][3]});
            if (nxt[t][0] != k) m[i] = nxt[t][0] - t + 1;
        }
    }
    vector<vector<int>> mm(k + 1);
    for (int i = 0; i < k; i++) if (m[i] != -1) mm[m[i]].push_back(i);

    ll q = 997;
    vector<ll> pw(2 * k + 1), spw(2 * k + 1);
    pw[0] = 1;
    for (int i = 1; i <= 2 * k; i++) pw[i] = pw[i - 1] * q;
    for (int i = 1; i <= 2 * k; i++) spw[i] = spw[i - 1] + pw[i - 1];

    vector<vector<ll>> hs(4, vector<ll>(k + 1));
    for (int i = 0; i < k; i++) hs[a[i]][i + 1] = pw[i];
    for (int i = 0; i < 4; i++) for (int j = 1; j <= k; j++) hs[i][j] += hs[i][j - 1];

    auto is_good_up = [&](int i, int m) {
        if (i + 2 * m > k) return false;
        if (s[i] == 'U' || s[i] == 'L' || s[i + m - 1] == 'U' || s[i + m - 1] == 'R') return false;
        ll h = (hs[1][i + m] - hs[1][i]) * pw[m];
        h += (hs[3][i + m] - hs[3][i]) * q * q * pw[m];
        h += (hs[0][i + 2 * m] - hs[0][i + m]) * q;
        return h * pw[2 * k - (i + 1 + m)] == spw[m] * pw[2 * k];
    };
    auto is_good_mid = [&](int i, int m) {
        if (i + 2 * m > k || i < m) return false;
        if (s[i] == 'L' || s[i + m - 1] == 'R') return false;
        ll h = (hs[1][i + m] - hs[1][i]) * pw[m];
        h += (hs[3][i + m] - hs[3][i]) * q * q * pw[m];
        h += (hs[0][i + 2 * m] - hs[0][i + m]) * q;
        h += (hs[2][i] - hs[2][i - m]) * q * pw[2 * m];
        return h * pw[2 * k - (i + 1 + m)] == spw[m] * pw[2 * k];
    };
    auto is_good_bot = [&](int i, int m) {
        if (i + m > k || i < m) return false;
        if (s[i] == 'D' || s[i] == 'L' || s[i + m - 1] == 'D' || s[i + m - 1] == 'R') return false;
        ll h = (hs[1][i + m] - hs[1][i]) * pw[m];
        h += (hs[3][i + m] - hs[3][i]) * q * q * pw[m];
        h += (hs[2][i] - hs[2][i - m]) * q * pw[2 * m];
        return h * pw[2 * k - (i + 1 + m)] == spw[m] * pw[2 * k];
    };

    ll ans = 0;
    for (int x : lr) ans += x;
    for (int cm = 1; cm * 2 <= k; cm++) {
        map<int, vector<int>> mp;
        for (int i : mm[cm]) mp[i % cm].push_back(i);

        for (auto it : mp) {
            auto v = it.second;
            reverse(v.begin(), v.end());

            int i = v.back();
            int cur = 0;
            while (i < k) {
                if (is_good_bot(i, cm)) {
                    ans += cur;
                }
                if (!is_good_mid(i, cm)) {
                    cur = 0;
                    if (v.empty()) break;
                    else i = v.back();
                }
                if (!v.empty() && i == v.back()) {
                    v.pop_back();
                    if (is_good_up(i, cm)) {
                        cur++;
                        ans -= max(0, lr[i] * 2 / cm - 1);
                    }
                }
                i += cm;
            }
        }
    }
    return ans;
}

int main() {
    string s;
    while (cin >> s) {
        cout << fastest(s) << endl;
    }
    return 0;
}
