#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
// #define make_unique(x) sort(all(x)); x.resize(unique(all(x)) - x.begin())

using namespace std;

inline int nxt() {
	int x;
	// scanf("%d", &x);
	cin >> x;
	return x;
}

using ld = long double;
const ld eps = 1e-8;

struct Seg {
	ld from;
	ld a, b, c; // on this segment func(s) = (as + b) / (s + c) = a + (b - ac) / (s + c)

	ld operator ()(ld x) const {
		return (a * x + b) / (x + c);
	}

	ld deriv(ld x) const {
		return (a * c - b) / (x + c) / (x + c);
	}
};

ostream& operator <<(ostream& ostr, const Seg& seg) {
	return ostr << "(from " << seg.from << " f(s) = (" << seg.a << " * s + " << seg.b << ") / (s + " << seg.c << ")";
}

struct Event {
	ld t;
	ld A, B;
	ld a, s;

	bool operator <(const Event& ot) const {
		return t < ot.t;
	}
};

ostream& operator <<(ostream& ostr, const Event& ev) {
	return ostr << "(from " << ev.t << " A += " << ev.A << ", B += " << ev.B << ", sum_a += " << ev.a << ", sum_s += " << ev.s << ")";
}

void solve() {
	int n = nxt(), q = nxt();
	vector<vector<Seg>> segs(n);
	vector<ld> Cs(n);
	for (int i = 0; i < n; ++i) {
		int k = nxt();
		vector<int> c(k);
		generate(all(c), nxt);
		vector<ld> p(k);
		generate(all(p), nxt);
		int C = accumulate(all(c), 0);
		Cs[i] = C;
		ld sump = accumulate(all(p), 0);
		for (auto& x : p) {
			x /= sump;
		}
		// func(s) = -1 + sum(abs(c[i] / (C + s) - p[i]) + c[i] / (C + s))
		// so events are c[i] / (C + s) = p[i] => c[i] = (C + s) * p[i] => s = (c[i] - C * p[i]) / p[i]
		Seg seg = {0., -1., -(ld)C, (ld)C};
		for (int j = 0; j < k; ++j) {
			seg.b += c[j] * 2;
			seg.a -= p[j];
			seg.b -= p[j] * C;
		}
		segs[i].push_back(seg);
		vector<pair<ld, int>> evs;
		for (int j = 0; j < k; ++j) {
			evs.push_back({(c[j] - C * p[j]) / p[j], j});
		}
		sort(all(evs));
		for (auto [t, j] : evs) {
			seg.b -= 2 * c[j];
			seg.a += 2 * p[j];
			seg.b += 2 * p[j] * C;
			if (t <= segs[i].back().from + eps) {
				segs[i].back() = seg;
			} else {
				seg.from = t;
				segs[i].push_back(seg);
			}
		}
		// for (auto ss : segs[i]) {
		// 	cerr << ss << "\n";
		// }
		// cerr << "\n";
	}

	vector<pair<long long, int>> qrs(q);
	for (int i = 0; i < q; ++i) {
		cin >> qrs[i].first;
		qrs[i].second = i;
	}
	sort(all(qrs));
	vector<ld> ans(q);
	reverse(all(qrs));

	vector<Event> evs;
	ld sum_a = 0, sum_s = 0;
	for (int i = 0; i < n; ++i) {
		evs.push_back({0, 0, 0, segs[i][0](0), 0});
		for (int j = 0; j < (int)segs[i].size(); ++j) {
			// on [from, to] our d(x) = (x + c) / sqrt(b - ac)
			// so x(d) = d * sqrt(b - ac) - c
			auto [from, a, b, c] = segs[i][j];
			if (b - a * c < eps) {
				continue;
			}
			ld s = sqrtl(b - a * c);
			ld to = segs[i][j + 1].from;
			evs.push_back({(from + c) / s, s, -c - from, (a * c - b) / (from + c), s});
			evs.push_back({(to + c) / s, -s, to + c, (b - a * c) / (to + c), -s});
		}
	}
	sort(all(evs));

	ld A = 0, B = 0;
	for (int i = 0; i < (int)evs.size(); ++i) {
		while (!qrs.empty() && qrs.back().first + eps < A * evs[i].t + B) {
			auto [x, idx] = qrs.back();
			qrs.pop_back();
			ld d = (x - B) / A;
			// cerr << x << ": " << A << " " << B << " " << d << "\n";
			// cerr << sum_a << " " << sum_s << "\n";
			ans[idx] = sum_a + sum_s / d;
		}
		A += evs[i].A, B += evs[i].B;
		sum_a += evs[i].a;
		sum_s += evs[i].s;
		if (i < (int)evs.size() - 1 && evs[i + 1].t < evs[i].t + eps) {
			continue;
		}
	}

	cout << setprecision(10) << fixed;
	for (auto x : ans) {
		cout << x << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1; // nxt();
	while (t--) {
		solve();
	}

	return 0;
}
