#include "connect-the-dots.h"

/**
 * Usage:
 *   ./perm `permutation`
 * Conditions:
 *   - `permutation`: "p1,p2,p3" - permutation of [1, 2, 3]
 * Effects:
 *   - Prints test (1; p1), (2; p2), (3; p3) to stdout
 */
int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);
  ensure(argc >= 2);

  const auto perm = split(argv[1], ',');
  ensure(perm.size() == ctd::POINTS_N);

  ctd::test test;
  for (size_t i = 0; i < ctd::POINTS_N; i++) {
    const auto p_i = strtol(perm[i].c_str(), nullptr, 10);
    ensure(1 <= p_i && p_i <= ctd::POINTS_N);
    const ctd::point point{static_cast<int>(i + 1), static_cast<int>(p_i)};

    auto begin = test.points.begin();
    auto end = test.points.begin() + i;
    ensure(std::find(begin, end, point) == end);
    *end = point;
  }

  test.print(std::cout);
}
