#include "connect-the-dots.h"

#include <map>

int main(int argc, char *argv[]) {
  registerValidation(argc, argv);

  std::map<ctd::point, size_t> points;
  for (size_t i = 0; i < ctd::POINTS_N; i++) {
    auto point = ctd::point::read(inf, true, format("point_%zu", i));
    auto point_iter = points.find(point);
    auto prev_index = point_iter == points.end() ? -1 : point_iter->second;
    ensuref(
      point_iter == points.end(),
      "Point (%d; %d) is present twice: #%zu and #%zu",
      point.x, point.y, prev_index, i);
    points[point] = i;
  }

  inf.readEof();
}
