#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

vector<int> count(string s) {
    vector<int> c(26);
    for (int i = 0; i < s.size(); i++) c[s[i] - 'A']++;
    return c;
}

string produce(string s, vector<int> sc, vector<int> tc) {
    vector<int> rc(26);
    string res;
    for (int i = 0; i < s.size(); i++) {
        int ch = s[i] - 'A';
        int cc = rc[ch] + 1;
        rc[ch] = cc;
        if (cc > sc[ch] - tc[ch]) res += s[i];
    }
    return res;
}

bool solve(string s, string t) {
    return produce(s, count(s), count(t)) == t;
}

string correct(string s) {
    vector<int> sc = count(s);
    vector<int> tc(26);
    while (true) {
        bool valid = false;
        for (int j = 0; j < 26; j++) {
            tc[j] = rnd.next(0, sc[j]);
            if (tc[j] > 0) valid = true;
        }
        if (valid) break;
    }
    string t = produce(s, sc, tc);
    assert(solve(s, t));
    return t;
}

char rndChar() {
    return 'A' + rnd.next(26);
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(1);
    int l1 = opt<int>(2);
    int l2 = opt<int>(3);
    cout << n << endl;
    for (int i = 0; i < n; i++) {
        string s;
        int sl = rnd.next(l1, l2);
        for (int j = 0; j < sl; j++) s += rndChar();
        bool ok = rnd.next(2) == 1;
        string t;
        if (ok) {
            t = correct(s);
        } else {
            while (true) {
                int tl, j, k;
                switch (rnd.next(3)) {
                case 0:
                    // just a random test
                    tl = rnd.next(l1, l2);
                    t = "";
                    for (int j = 0; j < tl; j++) t += rndChar();
                    break;
                case 1:
                    // take correct solution, replace one char with random
                    t = correct(s);
                    j = rnd.next(t.size());
                    t = t.substr(0, j) + rndChar() + t.substr(j + 1, t.size() - j - 1);
                    break;
                case 2:
                    // take correct solution, flip two chars
                    t = correct(s);
                    if (t.size() < 2) continue;
                    while (true) {
                        j = rnd.next(t.size());
                        k = rnd.next(t.size());
                        if (j < k) break;
                    }
                    t = t.substr(0, j) + t[k] + t.substr(j + 1, k - j - 1) + t[j] + t.substr(k + 1, t.size() - k - 1);
                    break;
                }
                if (!solve(s, t)) break;
            }
        }
        cout << s << " " << t << endl;
    }
}