#include "testlib.h"
#include <vector>

using namespace std;


int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);

    int l = inf.readInt();
    int n = inf.readInt();
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
    }

    auto read_answer = [&](InStream &str) {
        int last = 0;
        int max_len = 0;
        int min_len = l;
        for (int i = 0; i < n; i++) {
            int from = str.readInt(0, l, "f");
            int to = str.readInt(0, l, "s");
            if (from != last) {
                str.quitf(_wa, "Participant do not output valid split, first problem in segment %d (invalid start)", i);
            }
            if (from >= to) {
                str.quitf(_wa, "Participant do not output valid split, first problem in segment %d (non-positive length)", i);
            }
            if (from > a[i] || to < a[i]) {
                str.quitf(_wa, "Participant do not output valid split, first problem in segment %d (house not in segment)", i);
            }
            last = to;
            max_len = max(max_len, to - from);
            min_len = min(min_len, to - from);
        }
        if (last != l) {
            str.quitf(_wa, "Participant do not output valid split, first problem in segment %d (invalid end)", n - 1);
        }
        return max_len - min_len;
    };


    int jury_delta = read_answer(ans);
    int participant_delta = read_answer(ouf);

    if (jury_delta < participant_delta) {
        ouf.quitf(_wa, "Jury found better solution (j=%d vs p=%d)", jury_delta, participant_delta);
    }
    if (participant_delta < jury_delta) {
        ans.quitf(_wa, "OMG, participant found better solution (j=%d vs p=%d)", jury_delta, participant_delta);
    }

    quitf(_ok, "Minimal imbalance is %d\n", jury_delta);
}
