#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int start = atoi(argv[1]);
  int maxn = atoi(argv[2]);
  auto PrintRandom = [&](int n) {
    cout << n << '\n';
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      a[i] = rnd.next(1, n);
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) {
      cout << a[i] << " \n"[i == n - 1];
    }
  };
  vector<vector<int>> tests;
  for (int n = 2; n <= 8; n += 2) {
    vector<int> a(n);
    function<void(int)> Dfs = [&](int v) {
      if (v == n) {
        tests.push_back(a);
        return;
      }
      a[v] = (v > 0 ? a[v - 1] : 1);
      while (a[v] <= n) {
        Dfs(v + 1);
        a[v] += 1;
      }
    };
    Dfs(0);
  }
  shuffle(tests.begin(), tests.end());
  int ptr = 0;
  while (ptr < (int) tests.size()) {
    vector<vector<int>> now;
    int sum = 0;
    while (ptr < (int) tests.size()) {
      if (sum + (int) tests[ptr].size() > maxn) {
        break;
      }
      sum += (int) tests[ptr].size();
      now.push_back(tests[ptr++]);
    }
    startTest(start++);
    cout << now.size() << '\n';
    for (auto& t : now) {
      cout << t.size() << '\n';
      for (int i = 0; i < (int) t.size(); i++) {
        cout << t[i] << " \n"[i == (int) t.size() - 1];
      }
    }
  }
  int t = maxn / 2;
  while (t >= 1) {
    auto p = rnd.partition(t, maxn / 2, 1);
    startTest(start++);
    cout << t << '\n';
    for (int n : p) {
      PrintRandom(2 * n);
    } 
    t /= 2;
  }
  for (int it = 0; it < 20; it++) {
    startTest(start++);
    cout << 1 << '\n';
    PrintRandom(maxn);
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    for (int i = 0; i < maxn; i++) {
      cout << i + 1 << " \n"[i == maxn - 1];
    }
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    for (int i = 0; i < maxn; i++) {
      cout << 1 << " \n"[i == maxn - 1];
    }
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    for (int i = 0; i < maxn; i++) {
      cout << maxn << " \n"[i == maxn - 1];
    }
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    for (int i = 0; i < maxn; i++) {
      cout << (i < maxn / 2 ? 1 : i + 1) << " \n"[i == maxn - 1];
    }
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    for (int i = 0; i < maxn; i++) {
      cout << (i < maxn / 2 ? i + 1 : maxn) << " \n"[i == maxn - 1];
    }
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    cout << maxn << '\n';
    vector<int> a(maxn);
    for (int i = 0; i < maxn; i++) {
      a[i] = i / 2 + 1;
    }
    for (int i = 0; i < maxn; i += 2) {
      a[i] = max(1, a[i] - 2);
    }
    sort(a.begin(), a.end());
    for (int i = 2; i < maxn; i++) {
      a[i] += 1;
    }
    for (int i = 0; i < maxn; i++) {
      cout << a[i] << " \n"[i == maxn - 1];
    }
  }
  return 0;
}
