// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
const double PI = atan2(0, -1);

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}
	
	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	ll len2() const {
		return (ll) x * x + (ll) y * y;
	}

	double len() const {
		return sqrt(len2());
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator<=(point const& other) const {
		return x < other.x || (x == other.x && y <= other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll dot(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

double ang_between(point const& p1, point const& p2) {
	return atan2(cross(p1, p2), dot(p1, p2));
}

bool lies_on(point const& a, point const& b, point const& c) {
	return cross(b - a, c - a) == 0 && dot(b - a, c - a) >= 0 && dot(a - b, c - b) >= 0;
}

bool is_inside(vector<point> poly, point p) {
	set<int> have;
	for (int i = 0; i < szof(poly); ++i) {
		int nxt = (i + 1) % szof(poly);
		if (lies_on(poly[i], poly[nxt], p)) {
			return false;
		}
		have.insert(sign(cross(poly[nxt] - poly[i], p - poly[i])));
	}
	return !have.count(-1) || !have.count(1);
}

bool intersects(point a, point b, point c, point d) {
	if (cross(b - a, c - a) == 0 && cross(b - a, d - a) == 0) {
		if (b < a) {
			swap(a, b);
		}
		if (d < c) {
			swap(c, d);
		}
		return max(a, c) <= min(b, d);
	}
	return sign(cross(c - a, b - a)) * sign(cross(b - a, d - a)) >= 0 &&
		sign(cross(a - c, d - c)) * sign(cross(d - c, b - c)) >= 0;
}

struct bounding_box {
	int minx, maxx, miny, maxy;
	point get_rnd() const {
		int x = rnd.next(minx, maxx);
		int y = rnd.next(miny, maxy);
		return point(x, y);
	}
};

bounding_box get_bb(vector<point> points) {
	bounding_box ret;
	ret.minx = INF; ret.maxx = -INF;
	ret.miny = INF; ret.maxy = -INF;
	for (auto p : points) {
		ret.minx = min(ret.minx, p.x);
		ret.maxx = max(ret.maxx, p.x);
		ret.miny = min(ret.miny, p.y);
		ret.maxy = max(ret.maxy, p.y);
	}
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = 0;
	if (has_opt("n")) {
		n = opt<int>("n");
	}

	int maxc = 1e6;
	if (has_opt("maxc")) {
		maxc = opt<int>("maxc");
	}

	vector<point> points;
	vector<pii> edges;

	if (has_opt("rec")) {
		for (int i = 0; i < 3; ++i) {
			double ang = PI * 2 / 3 * i;
			int x = cos(ang) * maxc;
			int y = sin(ang) * maxc;
			points.push_back(point(x, y));
			edges.push_back({i, (i + 1) % 3});
		}

		deque<vector<int>> have = {{0, 1, 2}};

		for (int i = 3; i < n; ++i) {
			assert(szof(have));
			if (!has_opt("bfs")) {
				swap(have[rnd.next(szof(have))], have.front());
			}
			auto v = have.front();
			have.pop_front();
			vector<point> triang;
			for (int ind : v) {
				triang.push_back(points[ind]);
			}
			auto bb = get_bb(triang);
			bool fl = false;
			for (int j = 0; j < 100; ++j) {
				point p = bb.get_rnd();
				if (is_inside(triang, p)) {
					points.push_back(p);
					fl = true;
					break;
				}
			}
			if (fl) {
				int cur = szof(points) - 1;
				have.push_back({v[0], v[1], cur});
				have.push_back({v[0], v[2], cur});
				have.push_back({v[1], v[2], cur});
				edges.push_back({v[0], cur});
				edges.push_back({v[1], cur});
				edges.push_back({v[2], cur});
			} else {
				--i;
			}
		}
	} else if (has_opt("grid")) {
		int w = opt<int>("gridw");
		int h = opt<int>("gridh");
		int s = opt<int>("grids");
		for (int i = 0; i < w; ++i) {
			for (int j = 0; j < h; ++j) {
				points.push_back(point(i * s, j * s));
				if (i + 1 < w) {
					edges.push_back({i * h + j, (i + 1) * h + j});
				}
				if (j + 1 < h) {
					edges.push_back({i * h + j, i * h + j + 1});
				}
				if (i + 1 < w && j + 1 < h) {
					edges.push_back({i * h + j, (i + 1) * h + j + 1});
				}
			}
		}
		n = h * w;
	} else {
		if (opt<string>("points") == "random") {
			set<pii> have;
			for (int i = 0; i < n; ++i) {
				int x = rnd.next(-maxc, maxc);
				int y = rnd.next(-maxc, maxc);
				if (have.count({x, y})) {
					--i;
					continue;
				}
				have.insert({x, y});
				points.push_back(point(x, y));
			}
		} else {
			assert(false);
		}


		if (opt<string>("edges") == "conv_hull") {
			int c = rnd.next(n);
			vector<int> order;
			for (int i = 0; i < n; ++i) {
				if (i != c) {
					order.push_back(i);
				}
			}

			sort(order.begin(), order.end(), [&](int a, int b) {
				point p1 = points[a] - points[c];
				point p2 = points[b] - points[c];
				bool fl1 = p1.y > 0 || (p1.y == 0 && p1.x > 0);
				bool fl2 = p2.y > 0 || (p2.y == 0 && p2.x > 0);
				if (fl1 != fl2) {
					return fl1 < fl2;
				}
				ll val = cross(p1, p2);
				if (val == 0) {
					return p1.len2() > p2.len2();
				}
				return val > 0;
			});

			deque<int> st = {c};

			for (int i : order) {
				if (szof(st) >= 2 && cross(points[st.back()] - points[c], points[i] - points[c])) {
					edges.push_back({c, i});
				}
				edges.push_back({st.back(), i});
				while (szof(st) >= 2 && cross(points[st.back()] - points[st[szof(st) - 2]], points[i] - points[st.back()]) < 0) {
					st.pop_back();
					edges.push_back({st.back(), i});
				}

				st.push_back(i);
			}

			while (szof(st) >= 3 && cross(points[st[0]] - points[st.back()], points[st[1]] - points[st[0]]) < 0) {
				st.pop_front();
				edges.push_back({st.back(), st.front()});
			}
		} else if (opt<string>("edges") == "random") {
			vector<pii> all_edges;
			for (int i = 0; i < n; ++i) {
				for (int j = i + 1; j < n; ++j) {
					all_edges.push_back({i, j});
				}
			}
			shuffle(all_edges.begin(), all_edges.end());
			for (auto e : all_edges) {
				bool ok = true;
				for (int i = 0; i < n; ++i) {
					if (i == e.ff || i == e.ss) {
						continue;
					}
					if (lies_on(points[e.ff], points[e.ss], points[i])) {
						ok = false;
						break;
					}
				}
				for (auto e2 : edges) {
					if (e.ff == e2.ff || e.ff == e2.ss || e.ss == e2.ff || e.ss == e2.ss) {
						continue;
					}
					if (intersects(points[e.ff], points[e.ss], points[e2.ff], points[e2.ss])) {
						ok = false;
						break;
					}
				}
				if (ok) {
					edges.push_back(e);
				}
			}
		} else {
			assert(false);
		}
	}

	assert(n);

	shuffle(edges.begin(), edges.end());
	for (auto& e : edges) {
		if (rnd.next() < 0.5) {
			swap(e.ff, e.ss);
		}
	}

	vector<int> arrz;
	int maxz = maxc;
	if (has_opt("maxz")) {
		maxz = opt<int>("maxz");
	}

	int m = szof(edges);

	vector<bool> is_on_border(n);
	vector<vector<pii>> graph(n);
	for (int i = 0; i < szof(edges); ++i) {
		auto [u, v] = edges[i];
		graph[u].push_back({v, i * 2});
		graph[v].push_back({u, i * 2 + 1});
	}

	{
		vector<pii> where(m * 2, {-1, -1});

		for (int i = 0; i < n; ++i) {
			sort(graph[i].begin(), graph[i].end(), [&](auto a, auto b) {
				point v1 = points[a.ff] - points[i];
				point v2 = points[b.ff] - points[i];
				bool fl1 = v1.y > 0 || (v1.y == 0 && v1.x > 0);
				bool fl2 = v2.y > 0 || (v2.y == 0 && v2.x > 0);
				if (fl1 != fl2) {
					return fl1 < fl2;
				}
				return cross(v1, v2) > 0;
			});
			for (int j = 0; j < szof(graph[i]); ++j) {
				where[graph[i][j].ss] = {i, j};
			}
		}

		vector<bool> used_edge(m * 2);
		for (int i = 0; i < m * 2; ++i) {
			if (!used_edge[i]) {
				vector<int> face;
				int e = i;
				while (!used_edge[e]) {
					used_edge[e] = true;
					face.push_back(where[e].ff);
					auto [v, pos] = where[e ^ 1];
					pos = (pos - 1 + szof(graph[v])) % szof(graph[v]);
					e = graph[v][pos].ss;
				}

				double ang = 0;
				for (int j = 0; j < szof(face); ++j) {
					int next = (j + 1) % szof(face);
					int nnext = (j + 2) % szof(face);
					ang += ang_between(points[face[next]] - points[face[j]], points[face[nnext]] - points[face[next]]);
				}

				if (ang < 0) {
					for (int v : face) {
						is_on_border[v] = true;
					}
				}
			}
		}
	}

	if (opt<string>("z") == "random") {
		for (int i = 0; i < n; ++i) {
			if (is_on_border[i]) {
				arrz.push_back(0);
			} else {
				arrz.push_back(rnd.next(0, maxz));
			}
		}
	} else if (opt<string>("z") == "from_border") {
		vector<double> dist(n, 1e100);
		set<pair<double, int>> have;
		for (int i = 0; i < n; ++i) {
			if (is_on_border[i]) {
				dist[i] = 0;
				have.insert({0, i});
			}
		}

		while (szof(have)) {
			int v = have.begin()->ss;
			have.erase(have.begin());
			for (auto to : graph[v]) {
				double val = dist[v] + (points[to.ff] - points[v]).len();
				if (val < dist[to.ff]) {
					have.erase({dist[to.ff], to.ff});
					dist[to.ff] = val;
					have.insert({dist[to.ff], to.ff});
				}
			}
		}

		int k = opt<int>("sink_cnt");
		for (int i = 0; i < k; ++i) {
			int v;
			if (has_opt("peak_to_sink")) {
				v = max_element(dist.begin(), dist.end()) - dist.begin();
				dist[v] = rnd.next() * dist[v] / 2;
			} else {
				while (true) {
					v = rnd.next(n);
					if (!is_on_border[v]) {
						break;
					}
				}
				dist[v] = rnd.next() * dist[v];
			}
			have.insert({dist[v], v});
			while (szof(have)) {
				int v = have.begin()->ss;
				have.erase(have.begin());
				for (auto to : graph[v]) {
					double val = dist[v] + (points[to.ff] - points[v]).len();
					if (val < dist[to.ff]) {
						have.erase({dist[to.ff], to.ff});
						dist[to.ff] = val;
						have.insert({dist[to.ff], to.ff});
					}
				}
			}
		}

		double maxd = *max_element(dist.begin(), dist.end());
		for (auto& num : dist) {
			num /= maxd;
		}

		for (int i = 0; i < n; ++i) {
			if (opt<string>("zfu") == "linear") {
				arrz.push_back(round(dist[i] * maxz));
			} else if (opt<string>("zfu") == "sin") {
				arrz.push_back(round((sin(dist[i] * 2 - 1) + 1) / 2 * maxz));
			} else {
				assert(false);
			}
		}
	} else {
		assert(false);
	}

	cout << n << " " << szof(edges) << "\n";
	for (int i = 0; i < n; ++i) {
		cout << points[i].x << " " << points[i].y << " " << arrz[i] << "\n";
	}

	for (auto [u, v] : edges) {
		cout << u + 1 << " " << v + 1 << "\n";
	}

	int q = opt<int>("q");
	cout << q << "\n";

	if (opt<string>("queries") == "random") {
		for (int i = 0; i < q; ++i) {
			int h = rnd.next(0, maxz);
			int p = rnd.next(n);
			cout << h << " " << p + 1 << "\n";
		}
	} else if (opt<string>("queries") == "random_not_drown") {
		for (int i = 0; i < q; ++i) {
			int p = rnd.next(n);
			if (arrz[p] == 0) {
				--i;
				continue;
			}
			int h = rnd.next(0, arrz[p] - 1);
			cout << h << " " << p + 1 << "\n";
		}
	} else {
		assert(false);
	}

	return 0;
}