// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
const double PI = atan2(0, -1);

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}
	
	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	ll len2() const {
		return (ll) x * x + (ll) y * y;
	}

	double len() const {
		return sqrt(len2());
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator<=(point const& other) const {
		return x < other.x || (x == other.x && y <= other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll dot(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

double ang_between(point const& p1, point const& p2) {
	return atan2(cross(p1, p2), dot(p1, p2));
}

bool lies_on(point const& a, point const& b, point const& c) {
	return cross(b - a, c - a) == 0 && dot(b - a, c - a) >= 0 && dot(a - b, c - b) >= 0;
}

bool is_inside(vector<point> poly, point p) {
	set<int> have;
	for (int i = 0; i < szof(poly); ++i) {
		int nxt = (i + 1) % szof(poly);
		if (lies_on(poly[i], poly[nxt], p)) {
			return false;
		}
		have.insert(sign(cross(poly[nxt] - poly[i], p - poly[i])));
	}
	return !have.count(-1) || !have.count(1);
}

bool intersects(point a, point b, point c, point d) {
	if (cross(b - a, c - a) == 0 && cross(b - a, d - a) == 0) {
		if (b < a) {
			swap(a, b);
		}
		if (d < c) {
			swap(c, d);
		}
		return max(a, c) <= min(b, d);
	}
	return sign(cross(c - a, b - a)) * sign(cross(b - a, d - a)) >= 0 &&
		sign(cross(a - c, d - c)) * sign(cross(d - c, b - c)) >= 0;
}

struct bounding_box {
	int minx, maxx, miny, maxy;
	point get_rnd() const {
		int x = rnd.next(minx, maxx);
		int y = rnd.next(miny, maxy);
		return point(x, y);
	}
};

bounding_box get_bb(vector<point> points) {
	bounding_box ret;
	ret.minx = INF; ret.maxx = -INF;
	ret.miny = INF; ret.maxy = -INF;
	for (auto p : points) {
		ret.minx = min(ret.minx, p.x);
		ret.maxx = max(ret.maxx, p.x);
		ret.miny = min(ret.miny, p.y);
		ret.maxy = max(ret.maxy, p.y);
	}
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, m;
	cin >> n >> m;
	cout << n << "\n";
	vector<point> points;
	for (int i = 0; i < n; ++i) {
		int x, y, z;
		cin >> x >> y >> z;
		cout << x << " " << y << " " << z << "\n";
		points.push_back(point(x, y));
	}

	vector<vector<pii>> graph(n);

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back({b, i * 2});
		graph[b].push_back({a, i * 2 + 1});
	}

	vector<pii> where(m * 2);

	for (int i = 0; i < n; ++i) {
		sort(graph[i].begin(), graph[i].end(), [&](auto a, auto b) {
			point v1 = points[a.ff] - points[i];
			point v2 = points[b.ff] - points[i];
			bool fl1 = v1.y > 0 || (v1.y == 0 && v1.x > 0);
			bool fl2 = v2.y > 0 || (v2.y == 0 && v2.x > 0);
			if (fl1 != fl2) {
				return fl1 < fl2;
			}
			return cross(v1, v2) > 0;
		});

		for (int j = 0; j < szof(graph[i]); ++j) {
			where[graph[i][j].ss] = {i, j};
		}
	}

	vector<vector<int>> faces;
	vector<bool> used(m * 2);
	for (int i = 0; i < m * 2; ++i) {
		if (!used[i]) {
			int e = i;
			vector<int> face;
			while (!used[e]) {
				used[e] = true;
				face.push_back(where[e].ff);
				auto [v, pos] = where[e ^ 1];
				pos = (pos - 1 + szof(graph[v])) % szof(graph[v]);
				e = graph[v][pos].ss;
			}

			int pos = 0;
			for (int j = 0; j < szof(face); ++j) {
				if (points[face[j]] < points[face[pos]]) {
					pos = j;
				}
			}
			int prev = (pos - 1 + szof(face)) % szof(face);
			int nxt = (pos + 1) % szof(face);
			ll val = cross(points[face[prev]] - points[face[pos]], points[face[nxt]] - points[face[pos]]);
			assert(val);
			if (val < 0) {
				assert(szof(face) == 3);
				shuffle(face.begin(), face.end());
				faces.push_back(face);
			}
		}
	}

	shuffle(faces.begin(), faces.end());

	cout << szof(faces) << "\n";
	for (auto face : faces) {
		for (int i = 0; i < 3; ++i) {
			cout << face[i] + 1;
			if (i < 2) {
				cout << " ";
			}
		}
		cout << "\n";
	}

	int q;
	cin >> q;
	cout << q << "\n";

	for (int i = 0; i < q; ++i) {
		int h, p;
		cin >> h >> p;
		cout << h << " " << p << "\n";
	}

	return 0;
}