#include "testlib.h"

int const MAX_QUERIES =  2;

using namespace std;

vector<int> readPermutation(InStream& inf, int n) {
    vector<int> perm(n);
    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        perm[i] = inf.readInt(1, n, format("p[%d]", i));
        perm[i]--;
        if (used[perm[i]]) {
            quitf(_wa, "Expected a permutation, but got duplicate values: %d", perm[i] + 1);
        }
        used[perm[i]] = true;
    }
    return perm;
}

int main(int argc, char * argv[]) {
    registerInteraction(argc, argv);
    int t = inf.readInt();
    printf("%d\n", t);
    fflush(stdout);
    for (int i = 0; i < t; i++) {
        setTestCase(i + 1);
        int n = inf.readInt();
        int m = inf.readInt();
        printf("%d %d\n", n, m);
        fflush(stdout);
    
        int x1 = inf.readInt();
        int y1 = inf.readInt();
        int x2 = inf.readInt();
        int y2 = inf.readInt();
    
        int queries = 0;
        int MAX_QUERIES = 7;
        bool found1 = false, found2 = false;
        while (true) {
            string token = ouf.readWord();
            int x = ouf.readInt(1, n);
            int y = ouf.readInt(1, m);
            queries += 1;
            if (queries > MAX_QUERIES) {
                quitf(_wa, "Asked more than %d queries", MAX_QUERIES);
            }
            if (token == "DIG") {
                int res = 0;
                if (x == x1 && y == y1 && !found1) {
                    found1 = true;
                    res = 1;
                }
                if (x == x2 && y == y2 && !found2) {
                    found2 = true;
                    res = 1;
                }
                printf("%d\n", res);
                fflush(stdout);
            } else if (token == "SCAN") {
                printf("%d\n", abs(x - x1) + abs(y - y1) + abs(x - x2) + abs(y - y2));
                fflush(stdout);
            } else {
                quitf(_wa, "invalid command :%s", token);
            }
            if (found1 && found2) {
                break;
            }
        }
    }
    quitf(_ok, "");    
}
