// Validating solution for NERC'2021: Interactive Treasure Hunt
fun main() {
    val t = readLine()!!.toInt()
    require(t in 1..100)
    fun scan(r: Int, c: Int): Int {
        println("SCAN $r $c")
        return readLine()!!.toInt()
    }
    fun dig(r: Int, c: Int): Int {
        println("DIG $r $c")
        return readLine()!!.toInt().also { require(it in 0..1) }
    }
    infix fun Int.divNoRem(q: Int): Int = (this / q).also { require(this % q == 0) }
    fun solve(s: Int, d: Int): Pair<Int, Int> {
        // s - sum of distance to 1st row/col == |a - 1| + |b - 1| == a + b - 2
        // d - a difference between distance to solve row/col 1 and between row/col w in the middle ==
        //       |a - 1| + |b - 1| - |w - a| - |b - w| = 2 * a - 2
        val a = (d + 2) divNoRem 2
        val b = s - a + 2
        return Pair(a, b)
    }
    repeat(t) {
        val (n, m) = readLine()!!.split(" ")
            .also { require(it.size == 2) }
            .map { it.toInt().also { nm -> require(nm in 2..16) } }
        val s11 = scan(1, 1)
        val s1m = scan(1, m)
        val rs1 = ((s11 + s1m) divNoRem 2) - (m - 1) // sum of distances to 1st row
        val cs1 = ((s11 - s1m) divNoRem 2) + (m - 1) // sum of distances to 1st col
        val rw = 1 + rs1 / 2 // a row in between treasures
        val cw = 1 + cs1 / 2 // a col in between treasures
        val sw1 = scan(rw, 1)
        val s1w = scan(1, cw)
        val (ra, rb) = solve(rs1, s11 - sw1)
        val (ca, cb) = solve(cs1, s11 - s1w)
        // dig 4 in random order
        val list = listOf(Pair(ra, ca), Pair(rb, ca), Pair(ra, cb), Pair(rb, cb)).shuffled()
        var found = 0
        for ((r, c) in list) {
            found += dig(r, c)
            if (found == 2) break
        }
    }
}
