import kotlin.math.abs

private fun solve() {
	fun ask(x: Int, y: Int, op: String) = println("$op ${x + 1} ${y + 1}").let { readInt() }
	fun scan(x: Int, y: Int) = ask(x, y, "SCAN")
	fun dig(x: Int, y: Int) = ask(x, y, "DIG")
	fun dist(treasures: List<Int>, asked: Pair<Int, Int>): Int {
		return abs(asked.first - treasures[0]) + abs(asked.first - treasures[2]) +
				abs(asked.second - treasures[1]) + abs(asked.second - treasures[3])
	}

	val (wid, hei) = readInts()
	val universum = mutableListOf<List<Int>>()
	for (x2 in 0 until wid) for (x1 in 0..x2) for (y2 in 0 until hei) for (y1 in 0..y2) {
		if (x1 == x2 && y1 == y2) continue
		universum.add(listOf(x1, y1, x2, y2))
	}
	val alive = universum.indices.toMutableList()
	for (question in 0 until 4) {
		val points = (0 until wid).cartesianProduct(0 until hei)
		val bestAsk = if (question == 0) points[0] else points.minByOrNull { asked ->
			alive.groupBy { dist(universum[it], asked) }.maxOf { it.value.size }
		}!!
		val dist = scan(bestAsk.first, bestAsk.second)
		alive.retainAll { dist(universum[it], bestAsk) == dist }
	}
	val (x1, y1, x2, y2) = universum[alive[0]]
	if (dig(x1, y1) == 1) {
		dig(x2, y2)
	} else {
		dig(x1, y2); dig(x2, y1)
	}
}

fun main() = repeat(readInt()) { solve() }

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun <T, R> Iterable<T>.cartesianProduct(other: Iterable<R>) = flatMap { x -> other.map { y -> x to y } }
