import ru.ifmo.testlib.*

class Check : Checker {
	override fun test(inf: InStream, ouf: InStream, ans: InStream): Outcome {
		val n = inf.nextInt()
		val c = List(n) { IntArray(n) { inf.nextInt() } }

		val cumul = List(n + 1) { LongArray(n + 1) }
		for (i in 0 until n) for (j in 0 until n) {
			cumul[i + 1][j + 1] = cumul[i][j + 1] + cumul[i + 1][j] - cumul[i][j] + c[i][j]
		}
		fun cumul(iFrom: Int, iTo: Int, jFrom: Int, jTo: Int) =
			cumul[iTo][jTo] - cumul[iFrom][jTo] - cumul[iTo][jFrom] + cumul[iFrom][jFrom]
		fun withOther(iFrom: Int, iTo: Int) =
			cumul(0, iFrom, iFrom, iTo) + cumul(iTo, n, iFrom, iTo)

		fun answer(ouf: InStream): Long {
			val p = IntArray(n) { ouf.nextInt() }.map { it - 1 }
			fun calc(i: Int, j: Int, parent: Int): Long {
				if (i == j) return 0L
				val leaders = (i until j).filter { p[it] == parent }
				if (leaders.size != 1) throw ouf.quit(Outcome.Type.WA, "${leaders.size} leaders in [$i, $j)")
				val k = leaders[0]
				return calc(i, k, k) + withOther(i, k) + calc(k + 1, j, k) + withOther(k + 1, j)
			}
			return calc(0, n, -1)
		}

		val ja = answer(ans)
		val pa = answer(ouf)
		if (ja == pa) return Outcome(Outcome.Type.OK, "Cost = $pa")
		if (pa < ja) return Outcome(Outcome.Type.FAIL, "Better than jury, $pa < $ja")
		return Outcome(Outcome.Type.WA, "Not optimal, $pa > $ja")
	}
}

fun main(args: Array<String>) = CheckerFramework.main(args)
