#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector")
 
#include <bits/stdc++.h>
using namespace std;
 
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
 
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using uint = unsigned int;
using ull = unsigned long long;
 
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
default_random_engine generator;
 
void solve();
 
int task;
 
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);  
#endif 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(10) << fixed;
    cerr << setprecision(10) << fixed;  
 
    int tests = 1;
    // cin >> tests;
 
    for (int test = 1; test <= tests; ++test) {
        // cout << "Case #" << test << ": ";
        solve();
    }
 
#ifdef LOCAL
    cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << endl;
#endif
}
 
// ----------------------------------------------------------------- 

const int MAXN = 222;

ll c[MAXN][MAXN];
ll pref[MAXN][MAXN];
ll cost[MAXN][MAXN];
ll dp[MAXN][MAXN];
ll opt[MAXN][MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> c[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            pref[i][j + 1] = pref[i][j] + c[i][j];
        }
    }

    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            for (int i = l; i < r; ++i) {
                cost[l][r] += pref[i][n] - (pref[i][r] - pref[i][l]);
            }
        }
    } 

    for (int i = 0; i < n; ++i) {
        dp[i][i + 1] = 0;
        opt[i][i + 1] = i;
    }

    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            dp[l][r] = 1e18;
            for (int i = l; i < r; ++i) {
                ll cur = dp[l][i] + dp[i + 1][r] + cost[l][i] + cost[i + 1][r];
                if (cur < dp[l][r]) {
                    dp[l][r] = cur;
                    opt[l][r] = i;
                }
            }
        }
    }

    vector<int> order(n);

    function<void(int, int, int)> get = [&](int l, int r, int p) {
        if (l == r) {
            return;
        }
        int sep = opt[l][r];
        order[sep] = p;
        get(l, sep, sep);
        get(sep + 1, r, sep);
    };

    get(0, n, -1);

    cerr << dp[0][n] << endl;
    for (int x : order) {
        cout << x + 1 << " ";
    }
    cout << endl;
}   
