#include "testlib.h"

using namespace std;

struct edge {
	int v;
	int u;
	int len;
};

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	int n = opt<int>(1);
	int maxC = opt<int>(2);
	double prob = has_opt("p") ? opt<double>("p") : 1.0;
	int a, b;
	do {
		a = rnd.next(1, n);
		b = rnd.next(1, n);
	} while (a == b);
	vector<edge> edges;
	for (int i = 1; i <= n; i++) {
		if (i == a || i == b) continue;
		if (rnd.next() < prob) edges.push_back({a, i, rnd.next(maxC / 2, maxC)});
		if (rnd.next() < prob) edges.push_back({i, b, rnd.next(maxC / 2, maxC)});
	}
	cout << n << ' ' << edges.size() << '\n';
	cout << a << ' ' << b << '\n';
	shuffle(edges.begin(), edges.end());
	for (auto &e : edges) {
		cout << e.v << ' ' << e.u << ' ' << e.len << '\n';
	}
}
