#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const ll INF = (ll)1e18;
const int N = 20100;
int n;

struct Edge {
	int v, to;
	ll cap;

	Edge() : v(), to(), cap() {}
	Edge (int _v, int _to, ll _cap) : v(_v), to(_to), cap(_cap) {}
};
Edge ed[N];
int edSz;
vector<int> g[N];
int s, t;

void addEdge(int v, int to, ll cap) {
	g[v].push_back(edSz);
	ed[edSz++] = Edge(v, to, cap);
	g[to].push_back(edSz);
	ed[edSz++] = Edge(to, v, 0);
}

int dist[N];
int q[N];
int topQ;
int idx[N];

bool bfs() {
	for (int i = 0; i < n; i++)
		dist[i] = N;
	dist[s] = 0;
	topQ = 0;
	q[topQ++] = s;
	for (int i = 0; i < topQ; i++) {
		int v = q[i];
		for (int id : g[v]) {
			Edge e = ed[id];
			if (e.cap <= 0) continue;
			int to = e.to;
			if (dist[to] <= dist[v] + 1) continue;
			dist[to] = dist[v] + 1;
			q[topQ++] = to;
		}
	}
	return dist[t] < N;
}
ll dfs(int v, ll flow) {
	if (v == t || flow == 0) return flow;
	ll res = 0;
	for (int &i = idx[v]; i < (int)g[v].size(); i++) {
		int id = g[v][i];
		Edge e = ed[id];
		int to = e.to;
		if (dist[to] != dist[v] + 1) continue;
		ll df = dfs(to, min(flow, e.cap));
		ed[id].cap -= df;
		ed[id ^ 1].cap += df;
		flow -= df;
		res += df;
		if (flow == 0) return res;
	}
	return res;
}
ll Flow() {
	ll res = 0;
	while(bfs()) {
		for (int i = 0; i < n; i++)
			idx[i] = 0;
		res += dfs(s, INF);
	}
	return res;
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	int m;
	scanf("%d%d", &n, &m);
	s = 2 * n;
	t = 2 * n + 1;
	n = t + 1;
	int v, u;
	scanf("%d%d", &v, &u);
	v--;u--;
	addEdge(s, 2 * v, INF);
	addEdge(2 * v + 1, t, INF);
	addEdge(s, 2 * u + 1, INF);
	addEdge(2 * u, t, INF);
	while(m--) {
		int w;
		scanf("%d%d%d", &v, &u, &w);
		v--;u--;
		addEdge(2 * v, 2 * u + 1, w);
		addEdge(2 * v + 1, 2 * u, w);
		addEdge(2 * u, 2 * v + 1, w);
		addEdge(2 * u + 1, 2 * v, w);
	}
	printf("%lld\n", Flow());
	n = (n - 2) / 2;
	for (int i = 0; i < n; i++) {
		int mask = 0;
		if (dist[2 * i] < N)
			mask |= 1;
		if (dist[2 * i + 1] < N) mask |= 2;
		if (mask == 1) {
			printf("A");
		} else if (mask == 2) {
			printf("B");
		} else {
			printf("C");
		}
	}
	printf("\n");

	return 0;
}
