/**
 * Niyaz Nigmatullin
 */

#include <bits/stdc++.h>

using namespace std;

struct edge {
	int from;
	int to;
	int len;
};

mt19937 rng(58);

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0);
	int n, m;
	cin >> n >> m;
	int va, vb;
	cin >> va >> vb;
	--va;
	--vb;
	vector<edge> edges;
	for (int i = 0; i < m; i++) {
		int v, u, len;
		cin >> v >> u >> len;
		--v;
		--u;
		edges.push_back({v, u, len});
	}
	auto calc = [](vector<int> const &result, vector<edge> const &edges) {
		long long cost = 0;
		for (auto &e : edges) {
			if (result[e.from] == result[e.to] && result[e.from] != 2) {
				cost += 2 * e.len;
			} else if (result[e.from] != result[e.to] && (result[e.from] == 2 || result[e.to] == 2)) {
				cost += e.len;
			}
		}
		return cost;
	};
	long long best = 1LL << 60;
	vector<int> bestAns;
	int const T = 20;
	for (int t = 0; t < T; t++) {
		vector<int> result(n, 2);
		for (int i = 0; i < n; i++) {
			result[i] = (int) (rng() % 3);
		}
		result[va] = 0;
		result[vb] = 1;
		long long cost = calc(result, edges);
		int iters = 100000000 / T / m;
		for (int it = 0; it < iters; it++) {
			if (rng() % 2 == 0 || n <= 3) {
				int v;
				do {
					v = (int) (rng() % n);
				} while (v == va || v == vb);
				int add = (int) (rng() % 2 + 1);
				result[v] = (result[v] + add) % 3;
				long long curCost = calc(result, edges);
				if (curCost < cost) {
					cost = curCost;
				} else {
					result[v] = (result[v] - add + 3) % 3;
				}
			} else {
				int v, u;
				do {
					v = (int) (rng() % n);
					u = (int) (rng() % n);
				} while (v == u || v == va || v == vb || u == va || u == vb);
				swap(result[v], result[u]);
				long long curCost = calc(result, edges);
				if (curCost < cost) {
					cost = curCost;
				} else {
					swap(result[v], result[u]);
				}
			}
		}
		if (cost < best) {
			best = cost;
			bestAns = result;
		}
	}
	cout << best << endl;
	for (int i = 0; i < n; i++) {
		cout << (char) ('A' + bestAns[i]);
	}
	cout << '\n';
}
