/**
 * Niyaz Nigmatullin
 */

#include <bits/stdc++.h>

using namespace std;

struct edge {
	int from;
	int to;
	int len;
};

mt19937 rng(58);

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0);
	int n, m;
	cin >> n >> m;
	int va, vb;
	cin >> va >> vb;
	--va;
	--vb;
	vector<vector<edge>> edges(n);
	for (int i = 0; i < m; i++) {
		int v, u, len;
		cin >> v >> u >> len;
		--v;
		--u;
		edges[v].push_back({v, u, len});
		edges[u].push_back({u, v, len});
	}
	long long best = 1LL << 60;
	vector<int> bestAns;
	int const T = 100;
	for (int t = 0; t < T; t++) {
		vector<int> result(n, 2);
		for (int i = 0; i < n; i++) {
			result[i] = (int) (rng() % 3);
		}
		result[va] = 0;
		result[vb] = 1;
		vector<vector<long long>> w(n, vector<long long>(3));
		long long cost = 0;
		for (int i = 0; i < n; i++) {
			for (edge &e : edges[i]) {
				w[i][result[e.to]] += e.len;
			}
			if (result[i] == 0 || result[i] == 1) {
				cost += w[i][result[i]] + w[i][2];
			}
		}
		int iters = 100000;
		for (int it = 0; it < iters; it++) {
			int v;
			do {
				v = (int) (rng() % n);
			} while (v == va || v == vb);
			int add = (int) (rng() % 2 + 1);
			int old = result[v];
			result[v] = (result[v] + add) % 3;
			long long ncost = cost;
			if (old == 2) {
				ncost += w[v][2] + w[v][result[v]] - w[v][result[v] ^ 1];
			} else if (result[v] == 2) {
				ncost += w[v][old ^ 1] - w[v][2] - w[v][old];
			} else {
				ncost += 2 * w[v][old ^ 1] - 2 * w[v][old];
			}
			if (ncost < cost) {
				cost = ncost;
				for (edge &e : edges[v]) {
					w[e.to][old] -= e.len;
					w[e.to][result[v]] += e.len;
				}
			} else {
				result[v] = old;
			}
		}
		if (cost < best) {
			best = cost;
			bestAns = result;
		}
	}
	cout << best << endl;
	for (int i = 0; i < n; i++) {
		cout << (char) ('A' + bestAns[i]);
	}
	cout << '\n';
}
