#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

int n, s;
set<pair<int,int>> edges;

string to_string(vector<int> u) {
    string result = "[";
    forn(i, u.size()) {
        if (i > 0)
            result += ", ";
        result += to_string(u[i]);
    }
    result += "]";
    return __testlib_part(result);
}

vector<int> readPath(InStream& in) {
    int h = in.readInt(2, n, "h");
    vector<int> path(h);
    forn(i, h)
        path[i] = in.readInt(1, n, "v_i");

    // really path?
    forn(i, h - 1)
        if (edges.count(make_pair(path[i], path[i + 1])) == 0)
            in.quitf(_wa, "path '%s' has invalid edge (%d,%d)", to_string(path).c_str(), path[i], path[i + 1]);

    // starts with s?
    if (path[0] != s)
        in.quitf(_wa, "path '%s' doesn't start with s=%d", to_string(path).c_str(), s);

    // simple?
    if (set<int>(path.begin(), path.end()).size() != path.size())
        in.quitf(_wa, "path '%s' is not simple", to_string(path).c_str());
    
    return path;
}

bool readAnswer(InStream& in) {
    string yesno = in.readToken("Possible|Impossible", "Possible_Impossible");
    if (yesno == "Impossible")
        return false;

    vector<int> p1 = readPath(in);
    vector<int> p2 = readPath(in);

    // both end with t?
    if (p1.back() != p2.back())
        in.quitf(_wa, "paths do not end with the same vertex");

    // distinct?
    if (p1 == p2)
        in.quitf(_wa, "paths should be distinct");
    
    // do not share internal vertices?
    {
        set<int> internals;
        for (int i = 1; i < int(p1.size()) - 1; i++)
            internals.insert(p1[i]);
        for (int i = 1; i < int(p2.size()) - 1; i++)
            if (internals.count(p2[i]))
                in.quitf(_wa, "Vertex %d is in both paths", p2[i]);
    }

    return true;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    int m = inf.readInt();
    s = inf.readInt();
    forn(i, m) {
        int u = inf.readInt();
        int v = inf.readInt();
        edges.insert(make_pair(u, v));
    }

    bool ja = readAnswer(ans);
    bool pa = readAnswer(ouf);

    if (ja != pa) {
        if (pa)
            quitf(_fail, "Participant has answer, but jury doesn't");
        else
            quitf(_wa, "Jury has answer, but participant doesn't");
    }

    quitf(_ok, "n=%d, m=%d: %s", n, m, ja ? "possible" : "impossible");
}
