#include "testlib.h"
#include <cmath>

using namespace std;

vector<int> readPath(int n, int start, const set<pair<int, int>> &edges, set<int> &usedVertices) {
    int len = ouf.readInt(1, n + 1);
    vector<int> ans;
    for (int i = 0; i < len; i++) {
        ans.push_back(ouf.readInt(1, n));
    }
    if (ans[0] != start) {
        quitf(_wa, "Path starts in hall %d, but start hall should be %d", ans[0], start);
    }
    for (int i = 1; i < len; i++) {
        if (edges.find({ans[i - 1], ans[i]}) == edges.end()) {
            quitf(_wa, "Passage %d %d doesn't exist", ans[i - 1], ans[i]);
        }
    }
    usedVertices.insert(ans[len - 1]);
    for (int i = 1; i < len - 1; i++) {
        if (usedVertices.find(ans[i]) != usedVertices.end()) {
            quitf(_wa, "Duplicated hall %d", ans[i]);
        }
        usedVertices.insert(ans[i]);
    }
    return ans;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int m = inf.readInt();
    int s = inf.readInt();
    set<pair<int, int>> edges;
    for (int i = 0; i < m; i++) {
        int u = inf.readInt();
        int v = inf.readInt();
        edges.insert({u, v});
    }

    set<int> usedVertices;
    string result = ouf.readString("Possible|Impossible");
    string jury_result = ans.readString();
    if (result == "Impossible") {
        if (jury_result == "Possible") {
            quitf(_wa, "Solution exists, but not found");
        } else {
            quitf(_ok, "No solution");
        }
    }
    vector<int> first = readPath(n, s, edges, usedVertices);
    vector<int> second = readPath(n, s, edges, usedVertices);
    int t1 = first[first.size() - 1];
    int t2 = second[second.size() - 1];
    if (t1 != t2) {
        quitf(_wa, "Different ending halls: %d and %d", t1, t2);
    }
    if (jury_result == "Impossible") {
        quitf(_fail, "Found solution, but jury did not");
    } else {
        quitf(_ok, "Two paths from %d to %d", s, t1);
    }
}