#include "testlib.h"

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <ctime>
#include <climits>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <bitset>
#include <utility>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < int(n); i++)

using namespace std;

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    int n = opt<int>(1);
    int t = opt<int>(2);
    int k = opt<int>(3);

    vector<int> p(n);
    forn(i, n)
        if (i > 0)
            p[i] = rnd.wnext(i, t);

    vector<int> perm(n);
    forn(i, n)
        perm[i] = i;
    //shuffle(perm.begin() + 1, perm.end());

    vector<int> pp(n);
    for (int i = 1; i < n; i++)
        pp[perm[i]] = perm[p[i]];

    set<pair<int,int>> edges;
    for (int i = 1; i < n; i++)
        edges.insert({pp[i] + 1, i + 1});

    forn(i, k) {
        int u = rnd.next(1, n);
        int v = u;
        while (u == v)
            v = rnd.next(1, n);
        edges.insert({u, v});
    }
    
    printf("%d %d %d\n", n, int(edges.size()), 1);
    for (auto [u, v]: edges)
        printf("%d %d\n", u, v);
}
