#include <bits/stdc++.h>
using namespace std;
using ll = long long;

pair<int, int> dfs(int i, int p, int b, vector<int>& pre, vector<int>& branch, const vector<vector<int>>& g) {
	if (branch[i] != -1 && branch[i] != b) return {i, p};
	branch[i] = b;
	pre[i] = p;

	for (int t : g[i]) {
		if (t == p || branch[t] == b) continue;
		auto pr = dfs(t, i, b, pre, branch, g);
		if (pr.first != -1) return pr;
	}
	return {-1, -1};
}

vector<int> backtrack(int i, const vector<int>& pre) {
	vector<int> res;
	while(i != -1) {
		res.push_back(i);
		i = pre[i];
	}
	reverse(res.begin(), res.end());
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, s;
	cin >> n >> m >> s;
	--s;

	vector<vector<int>> g(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
    if (b == s) continue;
		g[a].push_back(b);
	}

	vector<int> pre(n, -1), branch(n, -1);
	branch[s] = s;
	pre[s] = -1;

	pair<int, int> res = {-1, -1};
	for (int t : g[s]) {
		res = dfs(t, s, t, pre, branch, g);
		if (res.first != -1) break;
	}
	if (res.first != -1) {
		cout << "Possible\n";

		vector<int> p0 = backtrack(res.first, pre);
		vector<int> p1 = backtrack(res.second, pre);
		p1.push_back(p0.back());

		cout << p0.size() << '\n';
		for (int i : p0) cout << i + 1 << ' '; cout << '\n';
		cout << p1.size() << '\n';
		for (int i : p1) cout << i + 1 << ' '; cout << '\n';
	} else {
		cout << "Impossible\n";
	}
}
