#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <ctime>
#include <string>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
	#define eprintf(...) 42
#endif

const int N = (int) 2e5 + 100;
vector <int> g[N];

int used[N];
int par[N];

void printPath(int v)
{
    vector <int> p;
    while (v != -1)
    {
        p.push_back(v);
        v = par[v];
    }
    reverse(p.begin(), p.end());
    printf("%d\n", (int) p.size());
    for (int x : p)
        printf("%d ", x + 1);
    printf("\n");
}

void printAns(int v, int pb)
{
    printf("Possible\n");
    printPath(v);
    par[v] = pb;
    printPath(v);
    exit(0);
}

void dfs(int v, int x)
{
    used[v] = x;

    for (int to : g[v])
    {
        if (used[to] == x)
            continue;
        if (used[to] != -1)
        {
            printAns(to, v);
            return;
        }
        par[to] = v;
        dfs(to, x);
    }
}

int main()
{
#ifdef LOCAL
	freopen ("input.txt", "r", stdin);
//	freopen ("output.txt", "w", stdout);
#endif

    int n, m, s;
    scanf("%d%d%d", &n, &m, &s);
    s--;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        a--;
        b--;
        if (b == s)
            continue;
        g[a].push_back(b);
    }
    par[s] = -1;
    memset(used, -1, sizeof used);
    for (int to : g[s])
    {
        if (used[to] != -1)
        {
            printAns(to, s);
            return 0;
        }
        dfs(to, to);
    }

    printf("Impossible\n");

	return 0;
}
