import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;

public class labyrinth_sm_wa {

    private ArrayList<Integer>[] es;
    private int[] parent;
    private int s;

    void solve() {
        int n = nextInt();
        int m = nextInt();
        s = nextInt() - 1;
        es = new ArrayList[n];

        for (int i = 0; i < n ; i++) {
            es[i] = new ArrayList<>();
        }
        for (int i = 0; i < m; i++) {
            int u = nextInt() - 1;
            int v = nextInt() - 1;
            es[u].add(v);
        }
        parent = new int[n];
        Arrays.fill(parent, -1);
        if (!dfs(s)) {
            out.println("Impossible");
        }
    }

    boolean dfs(int v) {
        for (int to : es[v]) {
            if (parent[to] == -1) {
                parent[to] = v;
                if (dfs(to)) {
                    return true;
                }
            } else {
                ArrayList<Integer> first = new ArrayList<>();
                {
                    int x = to;
                    while (x != s) {
                        first.add(x);
                        x = parent[x];
                    }
                    first.add(s);
                    Collections.reverse(first);
                }
                ArrayList<Integer> second = new ArrayList<>();
                {
                    int x = v;
                    second.add(to);
                    while (x != s) {
                        second.add(x);
                        x = parent[x];
                    }
                    second.add(s);
                    Collections.reverse(second);
                }
                out.println("Possible");
                print(first);
                print(second);
                return true;
            }
        }
        return false;
    }

    void print(ArrayList<Integer> path) {
        out.println(path.size());
        for (int i = 0; i < path.size(); i++) {
            out.print(path.get(i) + 1);
            if (i < path.size() - 1) {
                out.print(" ");
            }
        }
        out.println();
    }


    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                e.printStackTrace();
                System.exit(1);
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public static void main(String[] args) {
        new labyrinth_sm_wa().run();
    }
}
